#include <bits/stdc++.h>
typedef int_fast64_t lli;
using namespace std;
signed main()
{
    ios_base::sync_with_stdio(NULL);
    cin.tie(nullptr);
    cout.tie(nullptr);
    string s;
    cin >> s;
    vector<lli> ans(s.size(), 1e5);
    lli b = 0;
    for(lli i = 1; i < s.size(); i++)
    {
        if(s[i] < s[i-1]) ans[b] = i, b = i;
    }
    for(lli i = 0; i < s.size()-1; i++)
        if(s[i] <= s[i+1]) ans[i+1] = ans[i];
    lli q;
    cin >> q;
    //for(lli i = 0; i < ans.size(); i++) cout << ans[i] << " ";
    //cout << endl;
    map<pair<lli, lli>, lli> mp;
    while(q--)
    {
        lli a, b, c = 0, A, B;
        cin >> a >> b, a--, b--, A = a, B = b;
        while(a <= b)
        {
            if(mp[{a, b}]) {c += mp[{a, b}]; break;}
            c++;
            a = ans[a];
        }
        mp[{A, B}] = c;
        cout << c << endl;
    }
}
